//--------------------------------------------------------------------------
//
// Environment:
//      This software is part of models developed at BES collaboration
//      based on the EvtGen framework.  If you use all or part
//      of it, please give an appropriate acknowledgement.
//
// Copyright Information: See EvtGen/BesCopyright
//      Copyright (A) 2006      Ping Rong-Gang @IHEP
//
// Module:  EvtDIY.cc
//
// Description:  Class to boost a daughter momentum into the mother helicity system
//
// Modification history:
//
//    Ping R.-G.       December, 2006       Module created
//
//------------------------------------------------------------------------
//

#ifndef EVTHELSYS_HH
#define EVTHELSYS_HH

#include <iostream>
#include <fstream>
#include <TComplex.h>
//#include "EvtVector4R.h"
//#include "EvtVector3R.h"
#include <TLorentzVector.h>


using std::endl;
using std::fstream;

class EvtHelSys
{

//friend double   djmn(int    j, int    m, int    n, double theta);
//friend double   djmn(double j, double m, double n, double theta);
//friend TComplex Djmn(int    j, int    m, int    n, double   phi, double theta, double gamma);
//friend TComplex Djmn(double j, double m, double n, double   phi, double theta, double gamma);
public:

//destructor
virtual ~EvtHelSys();

// constructor
EvtHelSys();
EvtHelSys( const TLorentzVector & p4p, const TLorentzVector & p4d);

double getHelAng(const int i), Angles(const TLorentzVector, const int);

TLorentzVector checkparent(),checkdaug(),checkst(int i);

TLorentzVector Helrotate(const TLorentzVector p1, const double phi, const double theta);
private:
TLorentzVector _p4parent, _p4daug, _bp4p, _rotatep4p, _rotatep4d, _bst;

};

#endif

